cmiranda_studiogenesis/routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();



Route::group(['middleware' => ['auth']], function() {

    Route::get('/home', 'HomeController@index')->name('home');

    Route::get('tarifas/{id}/create', 'TarifasController@create')->name('tarifas.agregar');

    Route::resource('usuarios', 'UsuariosController');
    Route::resource('categorias', 'CategoriasController');
    Route::resource('productos', 'ProductosController');

    Route::resource('tarifas', 'TarifasController');

});

cmiranda_studiogenesis/app/Producto.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Producto extends Model
{
    protected $fillable = ['codigo_producto', 'nombre', 'descripcion', 'foto'];

    public function tarifas() {
        return $this->belongsToMany('App\Tarifa');
    }

    public function categorias() {
        return $this->belongsToMany('App\Categoria');
    }

}

cmiranda_studiogenesis/app/Http/Controllers/API/ProductosController.php
<?php

namespace App\Http\Controllers\API;

use App\Http\Controllers\Controller;
use App\Producto;
use App\Tarifa;
use Illuminate\Http\Request;

class ProductosController extends Controller {

    //Función index - Devolvemos una array en formato JSON con todos los Productos y Tarifa
    public function index(){
        //Cogemos todos los productos
        $productos = Producto::all();

        //Cogemos todas las tarifas
        $tarifas = Tarifa::all();

        //Devolvemos una respuesta json con una array de productos y tarifas
        return response()->json(array('productos' => $productos,'tarifas' => $tarifas));
    }

}

cmiranda_studiogenesis/app/Http/Controllers/ProductosController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Producto;
use App\Tarifa;
use App\Categoria;
use Carbon\Carbon;
use File;

class ProductosController extends Controller
{
    //Función index - Recogemos todos los Productos y las enviamos a la vista 'productos.index'.
    public function index() {
        $productos = Producto::paginate(10);

        return view('productos.index')->with('productos', $productos);
    }

    //Función create - Devolvemos la vista 'productos.create'.
    public function create() {
        $categorias = Categoria::all();

        return view('productos.create')->with('categorias', $categorias);
    }

    //Función store - Recogemos todos los datos vía Request, los validamos y se crea un nuevo producto.
    public function store(Request $request) {

        $request->validate([
            'fecha_inicio' => 'required',
            'fecha_fin' => 'required',
            'precio' => 'required',
            'nombre_producto' => 'required',
            'descripcion_producto' => 'required',
        ]);

        //Se crea una nueva Tarifa
        $tarifa = new Tarifa;
        $tarifa->fecha_inicio = $request->fecha_inicio;
        $tarifa->fecha_fin = $request->fecha_fin;
        $tarifa->precio = $request->precio;

        $tarifa->save();

        //Si recibimos una imagen.
        if($request->imagen){
            //Creamos un nombre con la fecha y la extensión de la imagen.
            $imageName = time().'.'.$request->imagen->getClientOriginalExtension();
            $request->imagen->move(public_path('imagenes/productos'), $imageName);
        }else{
            //Si no recibimos nada se pondrá una imagen por defecto.
            $imageName = "producto.png";
        }

        //Creamos el producto nuevo
        $producto = new Producto;

        $producto->nombre = $request->nombre_producto;
        $producto->descripcion = $request->descripcion_producto;
        $producto->foto = $imageName;
        $producto->precio = $request->precio;

        $producto->save();

        //Asociamos el producto con la categoría seleccionada.
        $producto->categorias()->attach($request->id_categorias);

        //Asociamos el producto con la tarifa creada para este producto.
        $producto->tarifas()->attach($tarifa);

        //Una vez creado nos redirigimos a la vista 'productos.index' con un mensaje de confirmación.
        return redirect()->route('productos.index')->with('success', 'Se ha añadido la categoria correctamente');
    }

    //Función edit - Encontramos el producto seleccionado por la ID y los enviamos a la vista 'productos.edit'.
    public function edit($id) {
        $producto = Producto::find($id);
        $categorias = Categoria::all();

        //Usamos el loop para coger la ID de la Categoría asociada con el Producto seleccionado.
        foreach($producto->categorias as $pCategoria){
            $idCategoria = $pCategoria->id;
        }

        //Pasamos el producto, las categorías y la ID de la Categoría del producto seleccionado.
        return view('productos.edit')->with('producto', $producto)->with('categorias', $categorias)->with('idPrCat', $idCategoria);
    }

    //Función update - Recogemos todos los datos del producto, la ID de la categoría a modificar y guardamos los cambios.
    public function update(Request $request, $id) {

        $request->validate([
            'nombre_producto' => 'required',
            'descripcion_producto' => 'required',
        ]);

        $producto = Producto::find($id);

        //Si recibimos una nueva imagen.
        if($request->imagen){
            //Se elimina la foto que tiene el producto actual.
            File::delete('imagenes/perfil/'.$producto->foto);

            //Creamos una nueva imagen y la movemos hasta el directorio 'imagenes/productos'
            $imagenNueva = time().'.'.request()->imagen->getClientOriginalExtension();
            $request->imagen->move(public_path('imagenes/productos'), $imagenNueva);

        }else{
            //Si no mantenemos el mismo nombre
            $imagenNueva = $producto->foto;
        }

        $producto->nombre = $request->nombre_producto;
        $producto->descripcion = $request->descripcion_producto;
        $producto->foto = $imagenNueva;
        $producto->categorias()->update(['categoria_id' => $request->id_categorias]);

        $producto->save();

        //Una vez modificado  nos redirigimos a la vista 'productos.index' con un mensaje de confirmación.
        return redirect()->route('productos.index')->with('success', 'Se ha modificado la categoria correctamente');
    }

    //Función  destroy - Encontramos el producto seleccionado y si existe se elimina.
    public function destroy($id) {
        $producto = Producto::find($id);

        if($producto) {
            $producto->delete();
            //También  eliminamos la imagen del producto a eliminar
            File::delete('imagenes/productos/'.$producto->foto);
        }

        //Una vez eliminado nos redirigimos a la vista 'productos.index' con un mensaje de confirmación.
        return redirect()->route('productos.index')->with('success','Se ha eliminado correctamente.');
    }

//Con esta función recogemos las tarifas validas para el producto que nosotros seleccionemos pasando su ID por parámetro
    /*public function getTarifa($fechaActual, $id){
        $producto = Producto::find($id);

        $hey = $producto->tarifas;
        $arrayTarifasValidas = array();

        foreach($hey as $tarifa){
            $tarifaQuery = Tarifa::where('fecha_fin', '>=', $fechaActual->toDateString())->where('fecha_inicio', '<=', $fechaActual->toDateString())->where('id', '=', $tarifa->id)->get()->first();

            array_push($arrayTarifasValidas,  $tarifaQuery);

            //dd($tarifaQuery); //Saca las validas
            //dd($producto->tarifas); //Saca las tarifas de el producto de arriba
        }

        return $arrayTarifasValidas;
    }*/
}

cmiranda_studiogenesis/resources/views/productos/create.blade.php
@extends('layouts.app')

@section('content')
    <div class="card">
        <div class="card-header">Añadir Producto</div>
        <div class="card-body">

            @if ($errors->any())
                <div class="alert alert-danger">
                    <ul>
                        @foreach ($errors->all() as $error)
                            <li>{{ $error }}</li>
                        @endforeach
                    </ul>
                </div>
            @endif

            <form method="POST" action="{{route('productos.store')}}" enctype="multipart/form-data">
                @csrf
                <div class="form-group">
                    <label for="nombre_producto">Nombre</label>
                    <input type="text" class="form-control" name="nombre_producto" id="nombre_producto" required>
                </div>

                <div class="form-group">
                    <label for="descripcion_producto">Descripción</label>
                    <textarea class="form-control" id="descripcion_producto" name="descripcion_producto" rows="3" required></textarea>
                </div>

                <div class="form-group">
                    <label for="id_categorias">Categoría</label>
                    <select class="form-control" name="id_categorias" id="id_categorias" required>
                        @foreach ($categorias as $categoria)
                            <option value="{{ $categoria->id }}">{{ $categoria->nombre_categoria }}</option>
                        @endforeach
                    </select>
                </div>

                <label>Tarifa</label>
                <div class="form-group row">
                    <div class="col-md-4">
                        <label>Fecha Inicio</label>
                        <input type="date" class="form-control" name="fecha_inicio" id="fecha_inicio" required>
                    </div>
                    <div class="col-md-4">
                        <label>Fecha Fin</label>
                        <input type="date" class="form-control" name="fecha_fin" id="fecha_fin" required>
                    </div>
                    <div class="col-md-4">
                        <label>Precio</label>
                        <input type="text" class="form-control" name="precio" id="precio" required>
                    </div>
                </div>

                <div class="form-group">
                    <label>Imagen de Producto</label>
                    <input type="file" class="form-control-file" id="imagen" name="imagen">
                    <br>
                </div>

                <a href="{{route('productos.index')}}" class="btn btn-danger">Atrás</a>
                <button type="submit" class="btn btn-primary">Añadir</button>
            </form>
        </div>
    </div>
@endsection

cmiranda_studiogenesis/resources/views/productos/edit.blade.php
@extends('layouts.app')

@section('content')
    <div class="card">
        <div class="card-header">Actualizar Producto</div>
        <div class="card-body">
            @if ($errors->any())
                <div class="alert alert-danger">
                    <ul>
                        @foreach ($errors->all() as $error)
                            <li>{{ $error }}</li>
                        @endforeach
                    </ul>
                </div>
            @endif

            <div class="row">
                <div class="col">
                    @if(strpos($producto->foto,'https') !== false)
                        <img src="{{$producto->foto}}" style="width:150px; height:150px; float:left; border-radius:50%; margin-right:25px; margin-bottom: 25px;">
                    @else
                        <img src="{{asset('imagenes/productos/'.$producto->foto)}}" style="width:150px; height:150px; float:left; border-radius:50%; margin-right:25px; margin-bottom: 25px;">
                    @endif
                    <h2>{{ $producto->nombre}}</h2>
                    <hr>
                </div>
            </div>

            <div class="row">
                <div class="col">
                    <form method="POST" action="{{route('productos.update', $producto->id)}}">
                        @csrf @method('PATCH')

                        <div class="form-group">
                            <label for="nombre_producto">Nombre</label>
                            <input type="text" class="form-control" name="nombre_producto" id="nombre_producto" value="{{$producto->nombre}}" required>
                        </div>

                        <div class="form-group">
                            <label for="descripcion_producto">Descripción</label>
                            <textarea class="form-control" id="descripcion_producto" name="descripcion_producto" rows="3" required>{{$producto->descripcion}}</textarea>
                        </div>

                        <div class="form-group">
                            <label for="id_categorias">Categorías</label>

                            <select class="form-control" name="id_categorias" id="id_categorias" required>
                                @foreach($categorias as $categoria)
                                    @if($categoria->id == $idPrCat)
                                        <option value="{{ $categoria->id }}" selected> {{$categoria->nombre_categoria}} </option>
                                    @else
                                        <option value="{{ $categoria->id }}"> {{$categoria->nombre_categoria}} </option>
                                    @endif
                                @endforeach
                            </select>
                        </div>

                        <div class="form-group">
                            <label>Imagen de Producto</label>
                            <input type="file" class="form-control-file" id="imagen" name="imagen">
                            <br>
                        </div>

                        <a href="{{route('productos.index')}}" class="btn btn-danger">Atrás</a>
                        <button type="submit" class="btn btn-primary">Actualizar</button>
                    </form>
                </div>
            </div>
        </div>
    </div>
@endsection

cmiranda_studiogenesis/resources/views/productos/index.blade.php
@extends('layouts.app')

@section('content')

    <div class="container">
        <div class="float-right">
            <a href="{{route('productos.create')}}" class="btn btn-primary">Añadir Producto</a>
        </div>
        <h1 style="font-size: 2.2rem">Lista de Productos</h1>

        @if(session()->get('success'))
            <div class="alert alert-success">
                {{ session()->get('success') }}
            </div>
            <br>
        @endif

        <div class="row justify-content-center">
            <div class="col">
                <table class="table">
                    <thead>
                    <tr>
                        <th scope="col">#ID</th>
                        <th scope="col">Nombre</th>
                        <th scope="col">Descripción</th>
                        <th scope="col">Categorías</th>
                        <th scope="col">Tarifa</th>
                        <th scope="col">Acción</th>
                    </tr>
                    </thead>
                    <tbody>
                    @foreach($productos as $producto)
                        <tr>
                            <th>{{$producto->id}}</th>
                            <th>{{$producto->nombre}}</th>
                            <th>{{$producto->descripcion}}</th>
                            <th> @foreach($producto->categorias as $categorias) {{$categorias->nombre_categoria }}@endforeach</th>
                            <th> {{$producto->precio}}</th>
                            <th>
                                <a href="{{route('productos.edit',$producto->id)}}" class="float-left">
                                    <button type="button" class="btn-primary btn-sm"><i class="far fa-edit"></i></button>
                                </a>

                                <form action="{{route('productos.destroy',$producto->id)}}" method="POST" class="float-left">
                                    @csrf @method('DELETE')
                                    <button type="submit" class="btn-danger btn-sm" onclick="return confirm('Estas seguro que quieres eliminar el producto?')"><i class="far fa-trash-alt"></i></button>
                                </form>
                                <a href="{{route('tarifas.show',$producto->id)}}" class="float-left">
                                    <button type="button" class="btn-success btn-sm"><i class="fas fa-dollar-sign"></i></button>
                                </a>
                            </th>
                        </tr>
                    @endforeach
                    </tbody>
                </table>
            </div>
        </div>
        {{$productos->links()}}
    </div>

@endsection